.686
.XMM
.model flat, C
option casemap:none

.code


align 4
strlen: ; size_t strlen(const char* str);
    mov   edx, [esp + 4]; load arg str
    pxor  xmm0, xmm0    ; xmm0 := 0
	movd  xmm2, edx		; store arg str in xmm2
	mov   ecx, edx		; copy arg str
	and   edx, -16		; 16-byte align ptr
	or    eax, -1
	pcmpeqb xmm0, [edx]	; check whole qw for 0s
	and   ecx, 15		; get #bytes of aligned dq before operand
	shl   eax, cl		; create mask for the bytes of aligned dq in operand
	pmovmskb ecx, xmm0	; collect mask of 0-bytes
	and   ecx, eax		; mask out any 0s that occur before 1st byte
	jnz   strlen_end	; found 0-byte, jump to end
	pxor   xmm0, xmm0	; xmm0 := 0
	add    edx, 16		; advance ptr
	align  4	; auto-align the loop
@@:
	movdqa xmm1, [edx]	; get next chunk
	add    edx, 16		; advance pointer
	pcmpeqb xmm1, xmm0	; check for 0s
	pmovmskb ecx, xmm1	; collect mask of 0-bytes
	test   ecx, ecx		; any 0-bytes?
	jz     @B		    ; no 0-bytes, so get next dq
	sub    edx, 16		; back up ptr
strlen_end:
	bsf   eax, ecx		; find first 1-bit (ie, first 0-byte)
	movd  ecx, xmm2; recover arg str from xmm2
	add   eax, edx		; get address of the 0-byte
	sub   eax, ecx		; subtract address of 1st byte to get string length
	ret
	
	
END;
